//problem3-4-1

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"
dsfmt_t dsfmt1;


int main(void){
	//the parameter of linear
	long long int linear_x = 1 , linear_y;
	long long int a = 1103515245;
	int c = 12345;
	int M = pow(2,8);
	int i;
	
	//the parameter of mt
	dsfmt_init_gen_rand(&dsfmt1,1);
	long long int mt_x = 1 , mt_y;
	
	//file
	FILE *fpw_linear , *fpw_mt;
	if ( (fpw_linear = fopen("linear.dat", "w")) == NULL) {
		printf("File Error : linear");
		exit(1);
	}
	if ( (fpw_mt   = fopen("mt.dat" , "w")) == NULL) {
		printf("File Error : mt");
		exit(1);
	}
			
	for(i=1;i<=1000;i++){
		linear_y = (a * linear_x + c) % M;
		mt_y  = (M-1) * dsfmt_genrand_close_open(&dsfmt1);
		
		fprintf( fpw_linear , "%3lld %3lld\n",linear_x , linear_y);
		fprintf( fpw_mt , "%3lld %3lld\n",mt_x , mt_y);
		
		linear_x = linear_y;
		mt_x = mt_y;
	}
	
	fclose(fpw_linear);
	fclose(fpw_mt);
	return 0;
}